package com.swagger.rest.repositories

import com.swagger.rest.models.Platform
import com.swagger.rest.models.Project
import org.springframework.data.domain.Page
import org.springframework.data.domain.Pageable
import org.springframework.data.jpa.repository.JpaRepository
import org.springframework.data.jpa.repository.JpaSpecificationExecutor
import org.springframework.data.jpa.repository.Query

interface PlatformRepository : JpaRepository<Platform, Long>, JpaSpecificationExecutor<Platform> {
    @Query("SELECT f.* FROM platform f WHERE name=?1 AND project_id=?2", nativeQuery = true)
    fun findByName(name: String?, project: String?): List<Platform>

    @Query("SELECT f.* FROM platform f WHERE project_id=?1", nativeQuery = true)
    fun findByProjectId(project: String?): List<Platform>

    @Query("SELECT * FROM platform WHERE project_id IN (SELECT project_id FROM project WHERE OWNER=?1) OR project_id IN (SELECT project_id FROM project_member WHERE user_id=?1)", nativeQuery = true)
    fun findOwnerOrMember(user: String, pageable: Pageable): Page<Platform>
}